<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers;
use App\Http\Helper\Helper;
use App\Managers\Profile\ProfileManager;
use App\Managers\User\UserManager;
use App\Managers\Paypal\PaypalManager;

class ProfileApiController extends Controller
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->profile = new ProfileManager();
        $this->user = new UserManager();
        $this->paypal = new PaypalManager();
    }
    
    public function profileInfo()
    {
        $profile = $this->profile->first();
        if(!$profile)
        {
            return response()->json('Profile Not Updated',500);
        }
        
        $userCount = ($this->user->getTotalActiveVotesUsersCount());
       // $userCount = (($this->user->getTotalActiveVotesUsersCount()->count()));
        $noOfVotes = $this->paypal->getTotalVotesCount();
        
        $res['club_name'] = $profile['name'];
        $res['user_count'] = $userCount->count();
        $res['no_of_votes'] = $noOfVotes['total'];
        
        return response()->json($res,200);
    }
}