<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\DecisionPollsOptionVotes;
use App\Managers\DecisionPollsOptionVotes\DecisionPollsOptionVotesModel;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use App\Managers\User\UserManager;
use Illuminate\Support\Facades\DB;
use App\Http\Helper\Helper;
use App\Managers\Paypal\PaypalManager;

class DecisionPollsOptionVotesManager extends DecisionPollsOptionVotesModel
{
    public function __construct()
    {
        $this->paypal = new PaypalManager();
    }
    
    public function insertData($data, $userID)
    {
        DB::beginTransaction();
        try 
        {
            $userBalanceVote = $noOfVotes = $data['votes'];
            $res = $this->insert($data);
            if(!$res)
            {
                return 0;
                exit;
            }
            $votes = $this->paypal->getAllCreditsOfUser($userID);
            $end = 0;
//            foreach($votes AS $vote)
//            {
//                if($end == 0 && $vote['no_of_votes'] > $vote['used_votes'])
//                {
//                    $balanceVoteForTransaction = $vote['no_of_votes'] - $vote['used_votes'];
//                    $availableVote = $vote['no_of_votes'];
//                    if($balanceVoteForTransaction == $userBalanceVote || $balanceVoteForTransaction > $userBalanceVote)
//                    {
//                        $availableVote = ($userBalanceVote + $vote['used_votes']);
//                        $end = 1;
//                    }
//                    
//                    $data1['used_votes'] = $availableVote;
//                    $update = $this->paypal->where('id', $vote['id'])->update($data1);
//                    if(!$update)
//                    {
//                        return 0;
//                        exit;
//                    }
//
//                    $userBalanceVote = $userBalanceVote - $balanceVoteForTransaction;
//                }
//            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function updateData($data, $UUID)
    {
        return $this->where('uuid', $UUID)->update($data);
    }
    
    public function getTotalLikesByUser($userID, $pollsID)
    {
        return $this->where('user_id', $userID)->where('decision_polls_id', $pollsID)->sum('votes');
    }
    
    public function getTotalLikesByOption()
    {
        return $this->select('decision_polls_option_id',DB::raw('SUM(votes) AS total_votes'))->groupBy('decision_polls_option_id')->get();
    }
    
    public function getTotalLikesForPoll($pollsID)
    {
        return $this->where('decision_polls_id', $pollsID)->sum('votes');
    }
    
    public function getTotalLikesForPollOption($optionID)
    {
        return $this->where('decision_polls_option_id', $optionID)->sum('votes');
    }
}