<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\TacticContainer;
use App\Managers\TacticContainer\TacticContainerModel;
use App\Managers\Tactics\TacticsManager;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use App\Http\Helper\Helper;
use Illuminate\Support\Facades\DB;
class TacticContainerManager extends TacticContainerModel
{
    public function __construct()
    {
         $this->helper = new Helper();
         $this->tacticsManager = new TacticsManager();
    }

    public function add($columns)
    {
        
    }
    
    public function getHighestVotedCaptain($scheduleID)
    {
        return $this->select(DB::raw("SUM(tactic_container.votes) as votes_count"), 'player.name')
                ->join('player', 'player.UUID', '=', 'tactic_container.captain')
                ->where('schedule_id', $scheduleID)
                ->groupBy('player.UUID')
                ->orderBy('votes_count', 'DESC')
                ->first();
    }
    
    public function getHighestVotedFreeKick($scheduleID)
    {
        return $this->select(DB::raw("SUM(tactic_container.votes) as votes_count"), 'player.name')
                ->join('player', 'player.UUID', '=', 'tactic_container.freekick')
                ->where('schedule_id', $scheduleID)
                ->groupBy('player.UUID')
                ->orderBy('votes_count', 'DESC')
                ->first();
    }
    
    public function getHighestVotedCorner($scheduleID)
    {
        return $this->select(DB::raw("SUM(tactic_container.votes) as votes_count"), 'player.name')
                ->join('player', 'player.UUID', '=', 'tactic_container.corner')
                ->where('schedule_id', $scheduleID)
                ->groupBy('player.UUID')
                ->orderBy('votes_count', 'DESC')
                ->first();
    }
    
    public function getHighestVotedPenalty($scheduleID)
    {
        return $this->select(DB::raw("SUM(tactic_container.votes) as votes_count"), 'player.name')
                ->join('player', 'player.UUID', '=', 'tactic_container.penalty')
                ->where('schedule_id', $scheduleID)
                ->groupBy('player.UUID')
                ->orderBy('votes_count', 'DESC')
                ->first();
    }
    
    public function getHighestVotedStr1($scheduleID)
    {
        return $this->select(DB::raw("SUM(tactic_container.votes) as votes_count"), 'str-1 AS str1')
                ->where('schedule_id', $scheduleID)
                ->where('str-1', '!=', null)
                ->groupBy('str-1')
                ->orderBy('votes_count', 'DESC')
                ->get();
    }
    
    public function getHighestVotedStr2($scheduleID)
    {
        return $this->select(DB::raw("SUM(tactic_container.votes) as votes_count"), 'str-2  AS str2')
                ->where('schedule_id', $scheduleID)
                ->where('str-2', '!=', null)
                ->groupBy('str-2')
                ->orderBy('votes_count', 'DESC')
                ->get();
    }
    
    public function getTotalVotesOfUser($scheduleID, $userID)
    {
        return $this->select(DB::raw('SUM(votes) AS total_votes'))->where('user_id', $userID)->where('schedule_id', $scheduleID)->first();
    }
    
    public function deleteData($UUID)
    {
        DB::beginTransaction();
        try 
        {   
            $this->tacticsManager->where('tactic_container_id', $UUID)->delete();
            $res = $this->where('UUID', $UUID)->delete();
            if(!$res)
            {
                DB::rollback();
                return 0;
                exit;
            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
            exit;
        }
    }
}