<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateSubstitutionProposalTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('substitution_proposal', function (Blueprint $table) {
            $table->increments('id');
            $table->uuid('UUID')->unique();
            $table->bigInteger('player_no')->default(1);
            $table->uuid('current_player_id');
            $table->uuid('substituted_player_id');
            $table->uuid('user_id');
            
            $table->timestamps();
            $table->softDeletes();
            
            $table->foreign('current_player_id')->references('UUID')->on('player');
            $table->foreign('substituted_player_id')->references('UUID')->on('player');
            $table->foreign('user_id')->references('UUID')->on('users');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('substitution_proposal');
    }
}
